##############
# Conditions #
##############
.if-default-branch-on-canonical-namespace: &if-default-branch-on-canonical-namespace
  if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH && $CI_PROJECT_NAMESPACE == "gitlab-org/ci-cd/merge-request-bot"'

.if-not-canonical-namespace: &if-not-canonical-namespace
  if: '$CI_PROJECT_NAMESPACE != "gitlab-org/ci-cd/merge-request-bot"'

.if-default-branch: &if-default-branch
  if: '$CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH'

.if-merge-request: &if-merge-request
  if: '$CI_MERGE_REQUEST_ID'

############
# Patterns #
############

.build-patterns: &build-patterns
  - "**/*.go"
  - go.mod
  - go.sum
  - Dockerfile
  - Makefile
  - .gitlab/ci/build.gitlab-ci.yml

.test-patterns: &test-patterns
  - "**/*.go"
  - go.mod
  - go.sum
  - Makefile
  - .gitlab/ci/test.gitlab-ci.yml

.lint-patterns: &lint-patterns
  - "**/*.go"
  - .golangci.yml
  - .gitlab/ci/test.gitlab-ci.yml

##############
# Test rules #
##############
.test:rules:go:
  rules:
  - <<: *if-merge-request
    changes: *test-patterns
  - <<: *if-default-branch

.test:rules:lint:
  rules:
  - <<: *if-merge-request
    changes: *lint-patterns
  - <<: *if-default-branch

###############
# Build rules #
###############
.build:rules:docker:
  rules:
  - <<: *if-merge-request
    changes: *build-patterns
  - <<: *if-default-branch-on-canonical-namespace

.build:rules:gcp-build:
  rules:
  - <<: *if-not-canonical-namespace
    when: never
  - <<: *if-default-branch
  - <<: *if-merge-request
    changes: *build-patterns

################
# Deploy rules #
################
.deploy:rules:cloud-run:
  rules:
  - <<: *if-default-branch-on-canonical-namespace
